<template>
  <div class="text-center">
    <v-dialog v-model="dialog" width="500">
      <template v-slot:activator="{ on, attrs }">
        <v-btn color="grey" text v-bind="attrs" v-on="on">Save</v-btn>
      </template>
      <v-card>
        <v-card-title class="text-h5 grey lighten-2">
          Save Asset Information (.json)
        </v-card-title>
        <v-card-text class="mt-5">자산 정보를 저장합니다.</v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="gray darken-1" text @click="dialog = false">
            Cancel
          </v-btn>
          <v-btn color="green darken-1" text @click="save"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  data() {
    return {
      dialog: false
    };
  },
  computed: {
    ...mapGetters(["fetchedAssetInformation"])
  },
  methods: {
    save() {
      const data = JSON.stringify(this.fetchedAssetInformation);
      const blob = new Blob([data], { type: "text/plain" });
      var e = document.createEvent("MouseEvents");
      var a = document.createElement("a");
      a.download = "asset_information_" + Date.now() + ".json";
      a.href = window.URL.createObjectURL(blob);
      a.dataset.downloadurl = ["text/json", a.download, a.href].join(":");
      e.initEvent(
        "click",
        true,
        false,
        window,
        0,
        0,
        0,
        0,
        0,
        false,
        false,
        false,
        false,
        0,
        null
      );
      a.dispatchEvent(e);
      this.dialog = false;
    }
  }
};
</script>
